const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const club_chat_messages = sequelize.define(
    'club_chat_messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

message_text: {
        type: DataTypes.TEXT,
      
      

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

is_deleted: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  club_chat_messages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop



    db.club_chat_messages.belongsTo(db.book_clubs, {
      as: 'book_club',
      foreignKey: {
        name: 'book_clubId',
      },
      constraints: false,
    });

    db.club_chat_messages.belongsTo(db.users, {
      as: 'sender',
      foreignKey: {
        name: 'senderId',
      },
      constraints: false,
    });



    db.club_chat_messages.hasMany(db.file, {
      as: 'attachment_files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.club_chat_messages.getTableName(),
        belongsToColumn: 'attachment_files',
      },
    });


    db.club_chat_messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.club_chat_messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return club_chat_messages;
};


